var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var BottomSheetComponent_1;
import { Component, ElementRef, EventEmitter, Input, Output } from "@angular/core";
const HTML_TEMPLATE = `
<div class="BottomSheetBackdrop" id="BottomSheetBackdrop"></div>

<div class="BottomSheetOuter" id="BottomSheetOuter" (click)="ChangeBottomSheetStateToClosed()" (scroll)="ScrollChanged($event)">
    <div class="BeforeMainBottomSheetBox"></div>
    <div class="BeforeMainBottomSheetBox CustomStateBox"></div>
    <div id="BottomSheet" class="BottomSheetBox" (click)="PreventClose($event)">
        <hr *ngIf="ShowIndicator">
        <div class="BottomSheetContent" [ngClass]="{'BottomSheetWithoutIndicator': !ShowIndicator}"><ng-content></ng-content></div>
    </div>
</div>
`;
const CSS_STYLE = `
.BottomSheetBackdrop
{
    position: absolute;
    height: 100%;
    width: 100vw;
    top: 0;
    left: 0;
    background-color: black;
    overflow: hidden;
    opacity: 0;
    visibility: hidden;
    transition: 0.3s;
    z-index: 5;
    cursor: pointer;
}

.BottomSheetOuter
{
    position: fixed;
    height: 200vh;
    width: 100vw;
    z-index: 100;
    top: 200%;
    left: 0;
    overflow: hidden;
    overflow-y: auto;
    scroll-snap-type: y mandatory;
    overflow: -moz-scrollbars-none;
    -ms-overflow-style: none;
    visibility: hidden;
    transition: 0.3s ease-out;
    cursor: pointer;
}

.ShowBottomSheetOuter
{
    top: 0;
    transition: top 0.3s ease;
    visibility: visible;
}

.ShowBackdrop
{
    opacity: 0.7;
    visibility: visible;
}

.BottomSheetOuter::-webkit-scrollbar
{
    -webkit-appearance: none;
    width: 0;
    height: 0;
}

.BottomSheetOuter::-webkit-scrollbar
{
    display: none;
}

.BeforeMainBottomSheetBox
{
    background-color: transparent;
    width: 100vw;
    scroll-snap-align: start;
    height: 100vh;
}

.CustomStateBox
{
    height: 0;
}

.BottomSheetBox
{
    background-color: white;
    scroll-snap-align: center;
    width: 100vw;
    height: auto;
    padding-bottom: 100vh;
    border-top-left-radius: 15px;
    border-top-right-radius: 15px;
    color: var(--ion-text-color);
    cursor: default;
}

hr
{ 
    width: 35px; 
    margin: 0 auto;
    margin-top: 10px;
    margin-bottom: 10px;
    height: 4px;
    border-radius: 5px;
    display: inline-block;
    background: #595858;
    position: relative;
    left: 50%;
    transform: translateX(-50%);
}

.BottomSheetContent
{
    overflow: scroll;
    max-height: 90vh;
    -ms-overflow-style: block;
}

.Fullscreen
{
    height: 90vh;
}

.BottomSheetWithoutIndicator
{
    max-height: 94vh;
}

@media (prefers-color-scheme: dark)
{
    .BottomSheetBox
    {
        background-color: #1C1C1E;
    }
    hr
    {
        background: #6C6C6D;
    }
}

@media only screen and (min-width: 768px)
{
    .BottomSheetOuter
    {
        position: fixed;
        height: 100vh;
        width: 100vw;
        z-index: 100;
        top: 200%;
        left: 0;
        overflow: hidden;
        visibility: hidden;
        transition: 0.5s ease-out;
    }

    .BeforeMainBottomSheetBox
    {
        display: none;
    }

    .BottomSheetBox
    {
        width: 600px;
        height: 600px;
        position: relative;
        top: 50%;
        left: 50%;
        padding: 0;
        transform: translate(-50%, -50%);
        border-radius: 15px;
        overflow: scroll;
    }

    hr
    {
        display: none;
    }

    .ShowBottomSheetOuter
    {
        top: 0;
        transition: top 0.3s;
        visibility: visible;
    }

    .BottomSheetContent
    {
        max-height: none;
    }

    .Fullscreen
    {
        height: 600px
    }
}
`;
let BottomSheetComponent = BottomSheetComponent_1 = class BottomSheetComponent {
    constructor(_elementRef) {
        this._elementRef = _elementRef;
        this._state = SheetStates.Closed;
        this.ShowIndicator = true;
        this.ShowBackdrop = true;
        this.Fullscreen = false;
        this.DockedStateHeight = 0;
        this.StateChange = new EventEmitter();
        this.ScrollChange = new EventEmitter();
    }
    get State() {
        return this._state;
    }
    set State(value) {
        if (!BottomSheetComponent_1.wasTriggeredRecently) {
            this._state = value;
            this.StateChange.emit(value);
            if (value == SheetStates.Opened || value == SheetStates.Docked) {
                this.ShowBottomSheet();
            }
            else {
                this.CloseBottomSheet();
            }
            BottomSheetComponent_1.wasTriggeredRecently = true;
            setTimeout(() => {
                BottomSheetComponent_1.wasTriggeredRecently = false;
            }, 200);
        }
    }
    ShowBottomSheet() {
        return __awaiter(this, void 0, void 0, function* () {
            const SheetPresenter = this._elementRef.nativeElement;
            BottomSheetComponent_1.randomString = yield this.MakeId(10);
            const ionRouter = window.document.querySelector("ion-router-outlet");
            SheetPresenter.setAttribute("id", `SheetPresenter${BottomSheetComponent_1.randomString}`);
            SheetPresenter.getElementsByClassName("BottomSheetBackdrop")[0].id = `BottomSheetBackdrop${BottomSheetComponent_1.randomString}`;
            SheetPresenter.getElementsByClassName("BottomSheetOuter")[0].id = `BottomSheetOuter${BottomSheetComponent_1.randomString}`;
            yield ionRouter.parentNode.insertBefore(SheetPresenter, ionRouter);
            const BottomSheetOuter = window.document.getElementById(`BottomSheetOuter${BottomSheetComponent_1.randomString}`);
            const Backdrop = window.document.getElementById(`BottomSheetBackdrop${BottomSheetComponent_1.randomString}`);
            const Content = window.document.getElementsByClassName("BottomSheetContent")[0];
            if (this.Fullscreen) {
                Content.classList.add("Fullscreen");
            }
            const CustomStateBox = window.document.getElementsByClassName("CustomStateBox")[0];
            CustomStateBox.style.height = (this.DockedStateHeight.toString() + "px");
            if (this.State == SheetStates.Opened) {
                this.OpenBottomSheet(BottomSheetOuter);
            }
            else if (this.State == SheetStates.Docked) {
                this.DockBottomSheet(BottomSheetOuter);
            }
            BottomSheetOuter.classList.add("ShowBottomSheetOuter");
            if (!this.ShowBackdrop) {
                Backdrop.style.opacity = "0";
            }
            Backdrop.classList.add("ShowBackdrop");
        });
    }
    OpenBottomSheet(bottomSheetOuter) {
        bottomSheetOuter.scrollTop = document.body.scrollHeight + this.DockedStateHeight;
    }
    DockBottomSheet(bottomSheetOuter) {
        bottomSheetOuter.scrollTop = document.body.scrollHeight;
    }
    CloseBottomSheet() {
        try {
            const BottomSheetOuter = window.document.getElementById(`BottomSheetOuter${BottomSheetComponent_1.randomString}`);
            const Backdrop = window.document.getElementById(`BottomSheetBackdrop${BottomSheetComponent_1.randomString}`);
            if (BottomSheetOuter != null) {
                BottomSheetOuter.classList.remove("ShowBottomSheetOuter");
                Backdrop.classList.remove("ShowBackdrop");
                setTimeout(() => __awaiter(this, void 0, void 0, function* () {
                    BottomSheetOuter.scrollTop = 0;
                    const SheetPresenter = yield document.querySelector(`bottom-sheet#SheetPresenter${BottomSheetComponent_1.randomString}`);
                    const ionApp = SheetPresenter.parentElement;
                    if (SheetPresenter != undefined) {
                        try {
                            yield ionApp.removeChild(SheetPresenter);
                        }
                        catch (e) {
                            console.log("ERROR", e);
                        }
                    }
                }), 100);
            }
        }
        catch (e) {
            console.error(`ERROR IN BOTTOM-SHEET COMPONENT WHILE DISMISING CARD: ${e}`);
        }
    }
    MakeId(length) {
        let result = "";
        const characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        const charactersLength = characters.length;
        for (let i = 0; i < length; i++) {
            result += characters.charAt(Math.floor(Math.random() * charactersLength));
        }
        return result;
    }
    ChangeBottomSheetStateToClosed() {
        this.State = SheetStates.Closed;
    }
    PreventClose(event) {
        event.stopPropagation();
    }
    ScrollChanged(event) {
        const Content = window.document.getElementsByClassName("BottomSheetContent")[0];
        this.ScrollChange.emit(event);
        if (event.target.scrollTop < 100) {
            this.State = SheetStates.Closed;
        }
        if (event.target.scrollTop == document.body.scrollHeight && Content != null) {
            BottomSheetComponent_1.wasTriggeredRecently = true;
            this.State = SheetStates.Docked;
            Content.style.overflowY = "hidden";
            this.StateChange.emit(this.State);
            setTimeout(() => {
                BottomSheetComponent_1.wasTriggeredRecently = false;
            }, 200);
        }
        else if (Content != null) {
            Content.style.overflowY = "scroll";
        }
        const OpenedHeight = event.target.scrollHeight - (document.body.scrollHeight * 2);
        if (event.target.scrollTop == OpenedHeight) {
            BottomSheetComponent_1.wasTriggeredRecently = true;
            this.State = SheetStates.Opened;
            this.StateChange.emit(SheetStates.Opened);
            setTimeout(() => {
                BottomSheetComponent_1.wasTriggeredRecently = false;
            }, 200);
        }
    }
};
BottomSheetComponent.wasTriggeredRecently = false;
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], BottomSheetComponent.prototype, "State", null);
__decorate([
    Input("ShowIndicator"),
    __metadata("design:type", Boolean)
], BottomSheetComponent.prototype, "ShowIndicator", void 0);
__decorate([
    Input("ShowBackdrop"),
    __metadata("design:type", Boolean)
], BottomSheetComponent.prototype, "ShowBackdrop", void 0);
__decorate([
    Input("Fullscreen"),
    __metadata("design:type", Boolean)
], BottomSheetComponent.prototype, "Fullscreen", void 0);
__decorate([
    Input("DockedHeight"),
    __metadata("design:type", Number)
], BottomSheetComponent.prototype, "DockedStateHeight", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], BottomSheetComponent.prototype, "StateChange", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], BottomSheetComponent.prototype, "ScrollChange", void 0);
BottomSheetComponent = BottomSheetComponent_1 = __decorate([
    Component({
        selector: "bottom-sheet",
        template: HTML_TEMPLATE,
        styles: [CSS_STYLE],
        outputs: ["State"]
    }),
    __metadata("design:paramtypes", [ElementRef])
], BottomSheetComponent);
export { BottomSheetComponent };
export var SheetStates;
(function (SheetStates) {
    SheetStates[SheetStates["Closed"] = 0] = "Closed";
    SheetStates[SheetStates["Docked"] = 1] = "Docked";
    SheetStates[SheetStates["Opened"] = 2] = "Opened";
})(SheetStates || (SheetStates = {}));
//# sourceMappingURL=bottom-sheet-component.js.map